/*   EXTRAITS DE LA LICENCE
	Copyright CEA, contributeurs : Luc BILLARD et Damien
	CALISTE, laboratoire L_Sim, (2001-2005)
  
	Adresse ml :
	BILLARD, non joignable par ml ;
	CALISTE, damien P caliste AT cea P fr.

	Ce logiciel est un programme informatique servant  visualiser des
	structures atomiques dans un rendu pseudo-3D. 

	Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
	respectant les principes de diffusion des logiciels libres. Vous pouvez
	utiliser, modifier et/ou redistribuer ce programme sous les conditions
	de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
	sur le site "http://www.cecill.info".

	Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
	pris connaissance de la licence CeCILL, et que vous en avez accept les
	termes (cf. le fichier Documentation/licence.fr.txt fourni avec ce logiciel).
*/

/*   LICENCE SUM UP
	Copyright CEA, contributors : Luc BILLARD et Damien
	CALISTE, laboratoire L_Sim, (2001-2005)

	E-mail address:
	BILLARD, not reachable any more ;
	CALISTE, damien P caliste AT cea P fr.

	This software is a computer program whose purpose is to visualize atomic
	configurations in 3D.

	This software is governed by the CeCILL  license under French law and
	abiding by the rules of distribution of free software.  You can  use, 
	modify and/ or redistribute the software under the terms of the CeCILL
	license as circulated by CEA, CNRS and INRIA at the following URL
	"http://www.cecill.info". 

	The fact that you are presently reading this means that you have had
	knowledge of the CeCILL license and that you accept its terms. You can
	find a copy of this licence shipped with this software at Documentation/licence.en.txt.
*/
#ifndef VISU_DATAFILE_H
#define VISU_DATAFILE_H

#include <glib.h>

enum
  {
    dataFile_normalize,
    dataFile_minMax
  };
enum
  {
    dataFile_rgb,
    dataFile_hsv
  };

int initDataFileModule();

void dataFileReDraw();

int dataFileSet_used(int val);
int dataFileGet_used();

int dataFileSet_file(char* filename, GString *message, int *errors);
char* dataFileGet_file();
/**
 * dataFileGet_fileMinMaxFromColumn:
 * @minMax: an allocated array of two floating point values ;
 * @column: an integer.
 *
 * This method is used to retrieve the minimum and the maximum
 * values of the column designed by the @column argument. Column
 * are numbered beginning at 0.
 *
 * Returns: FALSE if @column < 0 or if @column is greater than the number
 *          of read column or if no file has been set.
 */
gboolean dataFileGet_fileMinMaxFromColumn(float minMax[2], int column);

int dataFileSet_scaleType(int scale);
int dataFileGet_scaleType();

int dataFileSet_min(float min);
int dataFileSet_max(float max);
float dataFileGet_min();
float dataFileGet_max();

int dataFileSet_vectA(float val, int pos);
int dataFileSet_vectB(float val, int pos);
float* dataFileGet_vectA();
float* dataFileGet_vectB();

int dataFileSet_colUsed(int val, int pos);
int* dataFileGet_colUsed();

int dataFileGet_nbColumns();

int dataFileSet_colorType(int color);
int dataFileGet_colorType();

void dataFileGet_valuesTransformedInRGB(float* valuesTransformed, float* valuesFrom);



#endif
