/*   EXTRAITS DE LA LICENCE
	Copyright CEA, contributeurs : Luc BILLARD et Damien
	CALISTE, laboratoire L_Sim, (2001-2005)
  
	Adresse ml :
	BILLARD, non joignable par ml ;
	CALISTE, damien P caliste AT cea P fr.

	Ce logiciel est un programme informatique servant  visualiser des
	structures atomiques dans un rendu pseudo-3D. 

	Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
	respectant les principes de diffusion des logiciels libres. Vous pouvez
	utiliser, modifier et/ou redistribuer ce programme sous les conditions
	de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
	sur le site "http://www.cecill.info".

	Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
	pris connaissance de la licence CeCILL, et que vous en avez accept les
	termes (cf. le fichier Documentation/licence.fr.txt fourni avec ce logiciel).
*/

/*   LICENCE SUM UP
	Copyright CEA, contributors : Luc BILLARD et Damien
	CALISTE, laboratoire L_Sim, (2001-2005)

	E-mail address:
	BILLARD, not reachable any more ;
	CALISTE, damien P caliste AT cea P fr.

	This software is a computer program whose purpose is to visualize atomic
	configurations in 3D.

	This software is governed by the CeCILL  license under French law and
	abiding by the rules of distribution of free software.  You can  use, 
	modify and/ or redistribute the software under the terms of the CeCILL
	license as circulated by CEA, CNRS and INRIA at the following URL
	"http://www.cecill.info". 

	The fact that you are presently reading this means that you have had
	knowledge of the CeCILL license and that you accept its terms. You can
	find a copy of this licence shipped with this software at Documentation/licence.en.txt.
*/
#ifndef VISUSTUDIO_H
#define VISUSTUDIO_H

#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <gtk_main.h>
#include <visu_module.h>

/* This subpanel module allow the user to create
   a camera path and to export all views in images
   to later create a film. */

subPanel *visuStudioData;

/* Dealing with the parameters of the panel. */
#define FLAG_PARAMETER_STUDIO_NB "studio_preferedNumberOfViews"
#define DESC_PARAMETER_STUDIO_NB "Number of generated steps ; integer > 0"
#define PARAMETER_STUDIO_NB_DEFAULT 20
VisuModule *modulePanelStudio;
/* This function details how to read the preferedNumberOfViews
   parameter. */
int readNbPreferedNumberOfViews(char* value, VisuIO *io, gpointer userData);
/* These functions write all the element list to export there associated resources. */
void exportParametersPanelStudio(VisuIO *io);
int studio_preferedNumberOfViews;


/* Pointers to all spin widgets tha can fix a value. */
GtkWidget *spinThetaDeb;
GtkWidget *spinPhiDeb;
GtkWidget *spinDxDeb;
GtkWidget *spinDyDeb;
GtkWidget *spinGrossDeb;
GtkWidget *spinPerspDeb;
GtkWidget *spinThetaFin;
GtkWidget *spinPhiFin;
GtkWidget *spinDxFin;
GtkWidget *spinDyFin;
GtkWidget *spinGrossFin;
GtkWidget *spinPerspFin;
/* Radio buttons to choose which view to rebnder */
GtkWidget *radioButtonViewDeb;
GtkWidget *radioButtonViewFin;

/* parameters */
int studio_preferedNumberOfViews_default = 20;



/* Private functions. */
GtkWidget *createInteriorStudio();
int initParametersStudio();
char* getParameterValueStudio(const char* paramName);
int putParameterValueStudio(const char* paramName, const char* paramValue);

#endif

