/*   EXTRAITS DE LA LICENCE
	Copyright CEA, contributeurs : Luc BILLARD et Damien
	CALISTE, laboratoire L_Sim, (2001-2005)
  
	Adresse ml :
	BILLARD, non joignable par ml ;
	CALISTE, damien P caliste AT cea P fr.

	Ce logiciel est un programme informatique servant  visualiser des
	structures atomiques dans un rendu pseudo-3D. 

	Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
	respectant les principes de diffusion des logiciels libres. Vous pouvez
	utiliser, modifier et/ou redistribuer ce programme sous les conditions
	de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
	sur le site "http://www.cecill.info".

	Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
	pris connaissance de la licence CeCILL, et que vous en avez accept les
	termes (cf. le fichier Documentation/licence.fr.txt fourni avec ce logiciel).
*/

/*   LICENCE SUM UP
	Copyright CEA, contributors : Luc BILLARD et Damien
	CALISTE, laboratoire L_Sim, (2001-2005)

	E-mail address:
	BILLARD, not reachable any more ;
	CALISTE, damien P caliste AT cea P fr.

	This software is a computer program whose purpose is to visualize atomic
	configurations in 3D.

	This software is governed by the CeCILL  license under French law and
	abiding by the rules of distribution of free software.  You can  use, 
	modify and/ or redistribute the software under the terms of the CeCILL
	license as circulated by CEA, CNRS and INRIA at the following URL
	"http://www.cecill.info". 

	The fact that you are presently reading this means that you have had
	knowledge of the CeCILL license and that you accept its terms. You can
	find a copy of this licence shipped with this software at Documentation/licence.en.txt.
*/
#ifndef VISU_WINDOWINTERFACE_H
#define VISU_WINDOWINTERFACE_H

#include <glib.h>

struct SimplifiedEvents_struct
{
  int x, y;
  unsigned int button;
  int shiftMod, controlMod;
  int motion;
  char letter;
};
typedef struct SimplifiedEvents_struct SimplifiedEvents;

typedef void (*ActionFunc)(SimplifiedEvents *event);
struct CallbackFunctions_struct
{
  ActionFunc action;
  GDestroyNotify stop;
};
typedef struct CallbackFunctions_struct CallbackFunctions;

/*************************************/
/* Dealing with the rendering window */
/*************************************/
int initRenderingWindow(char* windowRef, char* iconRef, char* window_name,
			char* class_name, int width, int height);

GList* setObserveEventListener(CallbackFunctions *userCallbacks);
GList* setPickEventListener(CallbackFunctions *userCallbacks);
void removeEventListener(GList* listId);
void restoreStandardEventListener();
void stopStandardEventListener();
void addExposureEvent(ActionFunc action);
void removeExposureEvent();
/* gpointer getWindowHandler(gpointer window); */


/**
 * checkWindowSize:
 * @width: a pointer to store the width of the window ;
 * @height: a pointer to store the height of the window.
 *
 * Get the rendering window size by asking the X server.
 */
void checkWindowSize(unsigned int *width, unsigned int *height);

/* gpointer getWindowHandler(); */

void raiseRenderWindow();

void rename_window(char *nom);

#endif
